***

title: Run a card sale
icon: credit-card
published: true
intro: Take funds from a customer's card.
---------------------

For clean Markdown of any page, append .md to the page URL. For a complete documentation index, see https://docs.payroc.com/full-stack-guides/take-payments/payments/llms.txt. For full documentation content, see https://docs.payroc.com/full-stack-guides/take-payments/payments/llms-full.txt.

A merchant can use their POS to run card sales.

## Integration steps

* Run a sale.

## Before you begin

### Bearer tokens

Use our Identity Service to generate a Bearer token to include in the header of your requests. To generate your Bearer token, complete the following steps:

1. Include your API key in the x-api-key parameter in the header of a POST request.
2. Send your request to [https://identity.payroc.com/authorize](https://identity.payroc.com/authorize).

<Note>
  **Note:** You need to generate a new Bearer token before the previous Bearer token expires.
</Note>

#### Example request

```bash
curl --location --request POST 'https://identity.payroc.com/authorize' --header 'x-api-key: <api key>'
```

#### Example response

If your request is successful, we return a response that contains your Bearer token, information about its scope, and when it expires.

```json
{
  "access_token": "eyJhbGc....adQssw5c",
  "expires_in": 3600,
  "scope": "service_a service_b",
  "token_type": "Bearer"
}
```

### Headers

To create the header of each POST request, you must include the following parameters:

* **Content-Type:** Include application/json as the value for this parameter.
* **Authorization:** Include your Bearer token in this parameter.
* **Idempotency-Key:** Include a UUID v4 to make the request idempotent.

```bash
curl
-H "Content-Type: application/json"
-H "Authorization: <Bearer token>"
-H "Idempotency-Key: <UUID v4>"
```

### Errors

If your request is unsuccessful, we return an error. For more information about errors, see [Errors](/api/errors).

### Run a sale

To run a sale, send a POST request to our Payments endpoint.

| Endpoint   | Prefix     | URL                                                                              |
| :--------- | :--------- | :------------------------------------------------------------------------------- |
| Test       | `api.uat.` | [https://api.uat.payroc.com/v1/payments](https://api.uat.payroc.com/v1/payments) |
| Production | `api.`     | [https://api.payroc.com/v1/payments](https://api.payroc.com/v1/payments)         |

<Warning>
  **Important:** This method includes the following functions:

  * Tokenization
  * Pre-authorization
  * Currency conversion
  * Offline processing

  We don’t describe how to integrate with these functions in this guide.
</Warning>

### Request parameters

To create the body of your request, use the following parameters:

<EndpointSchemaSnippet endpoint="POST /payments" selector="request.body" />

### Example request

<EndpointRequestSnippet endpoint="POST /payments" />

### Response fields

If your request is successful, our gateway uses the card details to run a sale. The response contains the following fields:

<EndpointSchemaSnippet endpoint="POST /payments" selector="response.body" />

### Example response

<EndpointResponseSnippet endpoint="POST /payments" />

## Test cases

Before you run test cases, read the [Payments](/test/test-your-integration/payments) page in Test Your Integration.

### Run a card sale without a surcharge

Send a POST request to the following endpoint:

POST [https://api.uat.payroc.com/v1/payments](https://api.uat.payroc.com/v1/payments)

**Example response**

```json
{
	"paymentId": "F1I17KBL0E",
	"processingTerminalId": "3204001",
	"order": {
		"orderId": "Test_001",
		"dateTime": "2023-05-24T14:44:20.63+01:00",
		"amount": 4000,
		"currency": "USD"
	},
	"card": {
		"type": "Visa Credit",
		"entryMethod": "keyed",
		"cardNumber": "444433******1111",
		"expiryDate": "0334",
		"securityChecks": {
			"cvvResult": "M",
			"avsResult": "Y"
		}
	},
	"paymentResult": {
		"type": "sale",
		"status": "ready",
		"approvalCode": "OK14472",
		"authorizedAmount": 4000,
		"currency": "USD",
		"responseCode": "A",
		"responseMessage": "OK14472"
	}
}
```

### Run a card sale with a surcharge

Send a POST request to the following endpoint:

POST [https://api.uat.payroc.com/v1/payments](https://api.uat.payroc.com/v1/payments)

<Note>
  **Note:** If you are unsure whether your account supports surcharges, email our Integration team at [integrationsupport@payroc.com](mailto:integrationsupport@payroc.com).
</Note>

**Example response**

```json
{
	"paymentId": "CBA7UOVS0J",
	"processingTerminalId": "3204001",
	"order": {
		"orderId": "Test_005",
		"dateTime": "2023-05-24T14:48:39.548+01:00",
		"amount": 4160,
		"currency": "USD",
		"breakdown": {
			"subtotal": 4000,
			"surcharge": {
				"bypass": false,
				"amount": 160,
				"percentage": 4.0
			}
		}
	},
	"card": {
		"type": "Visa Credit",
		"entryMethod": "keyed",
		"cardNumber": "444433******1111",
		"expiryDate": "0334",
		"securityChecks": {
			"cvvResult": "M",
			"avsResult": "Y"
		}
	},
	"paymentResult": {
		"type": "sale",
		"status": "ready",
		"approvalCode": "OK14476",
		"authorizedAmount": 4160,
		"currency": "USD",
		"responseCode": "A",
		"responseMessage": "OK14476"
	}
}
```